precision highp float;
varying highp vec2 vTextureCoord;
uniform sampler2D iChannel0;

uniform float intensity;//[0.0 - 1.0] 0.0无噪点

void main()
{
    lowp vec4 textureColor = texture2D(iChannel0, vTextureCoord);
    float x = (vTextureCoord.x + 4.0) * (vTextureCoord.y + 4.0)  * 10.0;
    vec4 grainFactor = vec4(mod((mod(x, 13.0) + 1.0) * (mod(x, 123.0) + 1.0), 0.01)-0.005) * intensity * 200.0;
    gl_FragColor = textureColor + grainFactor * 0.18;
}