precision highp float;
varying highp vec2 vTextureCoord;
uniform sampler2D iChannel0;
uniform float intensity;// [-1, 1]

void main()
{
    lowp vec4 color = texture2D(iChannel0, vTextureCoord);
    float contrast = intensity * 0.7;
    lowp float t = -contrast * 0.5;
    color.rgb *= (contrast + 1.);
    color.rgb += t;
    gl_FragColor = color;
}

