precision highp float;
varying highp vec2 vTextureCoord;
uniform sampler2D iChannel0;

uniform float intensity;// [0 ~ 1.0]  0.0正常
void main()
{
    lowp vec4 textureColor = texture2D(iChannel0, vTextureCoord);

    float value = intensity * 0.35;
    float r = value + (1.0 - value) * textureColor.r;
    float g = value +(1.0 - value) * textureColor.g;
    float b = value + (1.0 - value) * textureColor.b;

    gl_FragColor = vec4(r, g, b, textureColor.a);

}