precision highp float;
varying highp vec2 vTextureCoord;
uniform sampler2D iChannel0;
uniform float intensity;//[-1.0, 1.0]
void main()
{
    lowp vec4 textureColor = texture2D(iChannel0, vTextureCoord);
    float tint = intensity;
    if (tint < 0.0){
        textureColor.g += -tint * 0.05;
        textureColor.r -= -tint * 0.05;
    } else {
        textureColor.g -= tint * 0.05;
        textureColor.r += tint * 0.05;
    }
    gl_FragColor = textureColor;

}