precision mediump float;
uniform sampler2D iChannel0;
uniform sampler2D iChannel1;
uniform lowp float progress;
varying highp vec2 vTextureCoord;
void main()
{
    lowp vec4 inComingColor = texture2D(iChannel1, vTextureCoord);
    lowp vec4 goingColor = texture2D(iChannel0, vTextureCoord);
    gl_FragColor = mix(goingColor, inComingColor, progress);
}